(
	global MST_ML_Roll
	try (destroyDialog MST_ML_Roll) catch()
	
	local fileFormats = #( "*.bmp", "*.exr", "*.hdr", "*.ifl", "*.jpe", "*.jpg", "*.jpeg", "*.pic", "*.png", "*.psd", "*.rgb", "*.rgba", "*.sgi", ".tif", "*.tga", "*.tiff", "*.tx")
	local fileTypes = "All Image Formats |*.png;*.bmp;*.tga;*.hdr;*.sgi;*.rgb;*.rgba;*.jpg;*.jpeg;*.jpe;*.exr;*.pic;*.tif;*.tiff;*.tx;*.tex;*.psd;*.ifl|Portable Network Graphics (*.png)|*.png|Windows Bitmap (*.bmp)|*.bmp|Targa Image File (*.tga)|*.tga|Radiance HDR Image (*.hdr)|*.hdr|Silicon Graphics (*.sgi;*.rgb;*.rgba)|*.sgi;*.rgb;*.rgba|JPEG Image File(*.jpg;*.jpeg;*.jpe)|*.jpg;*.jpeg;*.jpe|OpenEXR Image File (*.exr)|*.exr|Softimage PICT File (*.pic)|*.pic|Tagged Image File Format - TIFF (*.tif;*.tiff;*.tx)|*.tif;*.tiff;*.tx|Photoshop (*.tex,*.psd)|*.tex;*.psd|Image File List (*.ifl)|*.ifl|All Files (*.*)|*.*"
	local mapsRoot = undefined
	local theMaps = #()
	local mst = undefined
	local mstSlot = undefined
	local uvwSource = undefined
	
	fn isMatFree theMat =
	(
		(refs.dependentnodes theMat).count == 0
	)
	
	fn findMeditSlot =
	(
		for i = 1 to 25 do
		(
			if i != 25 then 
			(
				if isMatFree meditmaterials[i] do
				(
					exit with i
				)
			)
			else
			(
				exit with 1
			)
		)
	)
	
	rollout MST_ML_Roll "Multi-Sub Tex Mass Loader" width:336 height:208
	(
		GroupBox 'grp1' "Map Placement:" pos:[8,8] width:320 height:48 align:#left
		spinner 'spn1' "Put MST in slot #:" pos:[16,32] width:51 height:16 enabled:false range:[1,24,1] type:#integer scale:1 align:#left
		checkbox 'chk1' "Use First non-assigned slot" pos:[160,32] width:152 height:16 checked:true align:#left
		GroupBox 'grp2' "UVW Randomization" pos:[8,64] width:320 height:48 align:#left
		checkbox 'chk2' "Add UVW Randomizer" pos:[16,80] width:128 height:24 checked:true align:#left
		button 'btn1' "Click to search for textures and create the MST" pos:[8,120] width:320 height:32 align:#left
		button 'btn2' "Click to pick textures and create the MST" pos:[8,160] width:320 height:32 align:#left
		
		on spn1 changed val do
		(
			mstSlot = val
		)
		
		on chk1 changed state do
		(
			spn1.enabled = not state			
			if state then 
			(
				mstSlot	= undefined
			)
			else 
			(
				mstSlot = spn1.value
			)
		)
		on btn1 pressed do
		(
			--open the folder picker
			mapsRoot =  getSavePath caption:"Pick a folder to scan for textures"
			--now for the main process
			if mapsRoot != undefined do 
			(
				mst=VRayMultiSubTex name:(uniquename "MST_")
				mst.from_id=12
				mst.random_by_render_id = true
				--first, clean up the m/s texture
				mst.deleteSubtex 1 mst.texMap_num
		
				theMaps = #()
				
				for ext in fileFormats do
				(
					join theMaps (getFiles (mapsRoot + @"\" + ext ) recurse:true)
				)
				--add IDs if needed
				if theMaps.count > mst.texMap_num do mst.AddSubtex (theMaps.count-mst.texmap_num)
				--add Textures
				if chk2.checked then --add UVW Randomizer
				(
					uvwSource = VRayUVWRandomizer name:"UVWRandomizer"
					uvwSource.coords.mode_by_render_id = true

					for m=1 to theMaps.count do
					(
						mst.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m] mapSource:uvwSource
					)
				)
				else
				(
					for m=1 to theMaps.count do
					(
						mst.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m]
					)					
				)
				--cleanup
				mst.deleteSubtex (theMaps.count+1) (mst.texMap_num - theMaps.count)
			)
			if mstSlot == undefined then 
			(
				mstSlot = findMeditSlot()
				meditmaterials[mstSlot]=mst
				if uvwSource != undefined do
				(
					if (mstSlot+1) < 24 then 
					(
						meditmaterials[mstSlot+1]= uvwSource
					)
					else
					(
						meditmaterials[mstSlot-1]= uvwSource
					)
				)
			)
			else 
			(
				meditmaterials[mstSlot]=mst
				if uvwSource != undefined do
				(
					if (mstSlot+1) < 24 then 
					(
						meditmaterials[mstSlot+1]= uvwSource
					)
					else
					(
						meditmaterials[mstSlot-1]= uvwSource
					)
				)
			)
			uvwSource = undefined
			mst=undefined
		)
		
		on btn2 pressed do
		(
			--use a dotnet dialog to be able to multi-select
			
			theDialog = dotNetObject "System.Windows.Forms.OpenFileDialog" --create a OpenFileDialog
			theDialog.title = "PLEASE Select One Or More Files" --set the title
			theDialog.Multiselect = true --allow multiple files to be selected
			theDialog.Filter = fileTypes --specify the filter
			theDialog.FilterIndex = 1 --set the filter drop-down list to All Files
			theDialog.AutoUpgradeEnabled = true
			result = theDialog.showDialog() --display the dialog, get result into variable
			result.ToString() --when closed, convert the result to string
			result.Equals result.OK --returns TRUE if OK was pressed, FALSE otherwise
			result.Equals result.Cancel --returns TRUE if Cancel was pressed, FALSE otherwise
			theMaps = theDialog.fileNames --the selected filenames will be returned as an array
		
			--now for the main process
			if result.Equals result.OK do 
			(
				mst=VRayMultiSubTex name:(uniquename "MST_")
				mst.from_id=12
				mst.random_by_render_id = true
				--first, clean up the m/s texture
				mst.deleteSubtex 1 mst.texMap_num
		
				--add IDs if needed
				if theMaps.count > mst.texMap_num do mst.AddSubtex (theMaps.count-mst.texmap_num)
				--add Textures
				if chk2.checked then --add UVW Randomizer
				(
					uvwSource = VRayUVWRandomizer name:"UVWRandomizer"
					uvwSource.coords.mode_by_render_id = true
					for m=1 to theMaps.count do
					(
						mst.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m] mapSource:uvwSource
					)
				)
				else
				(
					for m=1 to theMaps.count do
					(
						mst.texmap[m] = vrayBitmap name:(getfilenamefile theMaps[m]) hdriMapName:theMaps[m]
					)					
				)
				--cleanup
				mst.deleteSubtex (theMaps.count+1) (mst.texMap_num - theMaps.count)
			)
			if mstSlot == undefined then 
			(
				mstSlot = findMeditSlot()
				meditmaterials[mstSlot]=mst
				if uvwSource != undefined do
				(
					if (mstSlot+1) < 24 then 
					(
						meditmaterials[mstSlot+1]= uvwSource
					)
					else
					(
						meditmaterials[mstSlot-1]= uvwSource
					)
				)
			)
			else 
			(
				meditmaterials[mstSlot]=mst
				if uvwSource != undefined do
				(
					if (mstSlot+1) < 24 then 
					(
						meditmaterials[mstSlot+1]= uvwSource
					)
					else
					(
						meditmaterials[mstSlot-1]= uvwSource
					)
				)
			)
		)
		uvwSource = undefined
		mst=undefined
	)
	
	CreateDialog MST_ML_Roll
)

-- genclassID()